# -*- coding: utf-8 -*-
module GirlsBar
  module Command
    class Input
      def initialize(resource)
        @subject = resource["subject"]
        @id   = GirlsBar::Filter.to_id resource["id"]
        @link = GirlsBar::Filter.to_id resource["link"]
      end

      def execute
        while true
          show_subject
          raw_data = gets
          key = GirlsBar::Filter.to_id raw_data
          case key
          when "exit", "quit"
            GirlsBar::Router.quit
          when "help"
            GirlsBar::Router.help
          else
            unless "#{key}".empty?
              GirlsBar::Data.set @id, raw_data
              GirlsBar::Router.move @link
              return true
            end
          end
          GirlsBar::Router.retry
        end
      end

      private
      def show_subject
        GirlsBar::Helper.set_color(:white) {
          print "\n"
          puts GirlsBar::Filter.to_subject @subject
          puts GirlsBar::Settings.delimiter
        }
        print GirlsBar::Settings.prompt
      end
    end
  end
end
