# -*- coding: utf-8 -*-
module GirlsBar
  module Filter
    def self.to_id(param)
      return param if param.is_a?(Fixnum)
      /^\d/ =~ param ? param.to_i : param.downcase.strip
    end

    def self.to_subject(str)
      return replace_vars_from_data(str)
    end

    def self.to_selection(str)
      return replace_vars_from_data(str)
    end

    def self.to_script(str)
      script = replace_vars_from_data(str)
      script.split("\n").join(" && ")
    end

    private
    def self.replace_vars_from_data(str)
      str.scan(/(\{\%\s*(\w+)?\s*%\})/).uniq.map {|match|
        str.gsub!(/#{match[0]}/, "#{GirlsBar::Data.get(match[1])}")
      } unless GirlsBar::Data.empty?
      return str
    end
  end
end
