# -*- coding: utf-8 -*-
module GirlsBar
  class Router
    def self.start
      show_boot_message
      show_banner unless GirlsBar::Settings.title.nil?
      execute_start
    end

    def self.restart
      execute_start
    end

    def self.quit
      show_quit_message
      exit
    end

    def self.help
      show_help_message
    end

    def self.retry
      show_retry_message
    end

    def self.move(id)
      if next_entry = GirlsBar::Entry.all.find {|entry| entry.id == id }
        next_entry.execute
      else
        show_invalid_link_message
        execute_start
      end
    end

    private
    def self.execute_start
      GirlsBar::Entry.first.execute
    end

    def self.show_boot_message
      GirlsBar::Helper.set_color(:red) {
        puts GirlsBar::Settings.boot_message
      }
    end

    def self.show_quit_message
      GirlsBar::Helper.set_color(:green) {
        print "\n"
        puts GirlsBar::Settings.quit_message
      }
    end

    def self.show_help_message
      GirlsBar::Helper.set_color(:green) {
        print "\n"
        puts GirlsBar::Settings.help_message
      }
    end

    def self.show_retry_message
      GirlsBar::Helper.set_color(:red) {
        print "\n"
        puts GirlsBar::Settings.retry_message
      }
    end

    def self.show_invalid_link_message
      GirlsBar::Helper.set_color(:red) {
        print "\n"
        puts GirlsBar::Settings.invalid_link_message
      }
    end

    def self.show_banner
      GirlsBar::Helper.set_color(:yellow) {
        print [
          nil,
          GirlsBar::Settings.delimiter,
          GirlsBar::Settings.title,
          GirlsBar::Settings.delimiter,
          GirlsBar::Settings.description
        ].join("\n")
      }
    end
  end
end
