# -*- coding: utf-8 -*-
module GirlsBar
  class Settings
    def self.setup(resource=nil)
      resource ||= {}
      @title       = resource["title"]
      @description = resource["description"]
      @delimiter   = set_delimiter(resource["delimiter"])
      @prompt      = resource["prompt"] || GirlsBar::DEFAULT_SETTINGS[:prompt]
      @boot_message  = GirlsBar::DEFAULT_SETTINGS[:messages][:boot]
      @quit_message  = GirlsBar::DEFAULT_SETTINGS[:messages][:quit]
      @help_message  = resource["help_message"] || @boot_message
      @retry_message = GirlsBar::DEFAULT_SETTINGS[:messages][:retry]
      @invalid_link_message = GirlsBar::DEFAULT_SETTINGS[:messages][:invalid_link]
      instance_variables.each do |name|
        self.define_singleton_method(name[1..-1]) { instance_variable_get(:"#{name}") }
      end
    end

    private
    def self.set_delimiter(resource=nil)
      resource ||= {}
      string = resource["character"] || GirlsBar::DEFAULT_SETTINGS[:delimiter][:character]
      count  = resource["count"]     || GirlsBar::DEFAULT_SETTINGS[:delimiter][:count]
      string * count
    end
  end
end
